#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>

#include "dnsrh.h"

#define DEVICE_PATH "/dev/dnsrh"

int main(int argc, char * argv[]) { 
  int err = 0;
  int handle = 0;
  int i = 0;
  ip_pair * ipp = NULL;

  printf("Started the checker.\n");

  handle = open(DEVICE_PATH, O_RDWR);

  if (handle < 0) {
    printf ("Can't open device file: %s: %s\n", DEVICE_PATH, strerror(errno));
    exit(1);
  }

  ipp = (ip_pair *) malloc(sizeof(ip_pair));

  for (i = 0; i < 16; i++) { 
    ipp->v6[i] = atoi(argv[1]);
  }

  for (i = 0; i < 4; i++) { 
    ipp->v4[i] = 0;
  }

  /* Add our initial V6 addr */
  /* segfaulting... but only when already added */
  err = ioctl(handle, IOCTL_ADD_V6, ipp); 
  printf("IOCTL_ADD_V6 returned: %d\n", err);
  printf("got back: %d.%d.%d.%d\n", ipp->v4[0], ipp->v4[1], ipp->v4[2], ipp->v4[3]);
  err = 0;


  /* see if we can fill the v6 again */
  for (i = 0; i < 16; i++) { 
    ipp->v6[i] = 0;
  }

  err = ioctl(handle, IOCTL_CHECK_FOR_V6, ipp);
  printf("IOCTL_CHECK_FOR_V6 returned: %d\nV6 data: ", err);
  for (i = 0; i < 16; i++) { 
    printf("%d.", ipp->v6[i]);
  }
  printf("\n");
  err = 0;


  /* see if we can fill v4 */
  for (i = 0; i < 4; i++) { 
    ipp->v4[i] = 0;
  }

  err = ioctl(handle, IOCTL_CHECK_FOR_V4, ipp);
  printf("IOCTL_CHECK_FOR_V4 returned: %d\n", err);
  printf("got back: %d.%d.%d.%d\n", ipp->v4[0], ipp->v4[1], ipp->v4[2], ipp->v4[3]);
  err = 0;

  /* Cleanup */
  close(handle);
  free(ipp);

  return 0;
}
